warning off
% states: distance, v_follower, v_target
Ts = 1;

A=[1 -1 1; 0 1 0; 0 0 1];
B=[0; 1; 0];
C=eye(3);
D=zeros(3,1);
model = struct('A', A, 'B', B);

N = 10;
umin = -8; 
umax = 8; 
xmin=[0.1; 0; 0];
xmax = [1e4; 20; 20];  
nx = length(xmin);
nu = length(umin);

x = sdpvar(nx, N+1, 'full');
u = sdpvar(nu, N, 'full');
E = sdpvar(nu, N, 'full');
zu = sdpvar(nu, N, 'full');
zx = sdpvar(nx, N+1, 'full');
zd = sdpvar(1, N, 'full');

Qd = 1;
Qa = 1;
Qzx = 1e3*eye(nx);
Qzu = 1e3*eye(nu);
Qzd = 1e3;

soft_x = true;
soft_u = false;
soft_d = true;
dref = sdpvar(1);
con = [];
obj = 0;
for k = 1:N
    con = con + [ x(:, k+1) == A*x(:, k) + B*u(:, k) ]; % prediction equation
    if soft_x
        con = con + [ -zx(:, k)+xmin <= x(:, k) <= xmax+zx(:,k); zx(:, k)>=0 ];
    else
        con = con + [ xmin <= x(:, k) <= xmax ];
    end
    if soft_u
        con = con + [ -zu(:, k)+umin <= u(:, k) <= umax+zu(:,k); zu(:, k)>=0 ];
    else
        con = con + [ umin <= u(:, k) <= umax ];
    end
    
    con = con + [E(:,k)>=Qa*u(:,k); E(:,k)>=0];
    
        d = x(1, k);  % rozostup
        vf = x(2, k); % nasa rychlost
        vl = x(3, k); % rychlost toho pred nami
    
   
%     if soft_d
%         con = con + [ vf-vl <= d + zd(:, k); zd(:, k)>=0, 1];
%     else
%         con = con + [ vf-vl <= d ];
%     end
    
    obj = obj + Qd*(d-dref)^2 +Qa*E(:, k);
%     obj = obj + norm(Qd*(d-dref),1) + norm(Qa*u(:,k), 1);
    
    if soft_x
        %obj = obj + norm(Qzx*zx(:,k), 1);% zx(:, k)'*Qzx*zx(:, k);
        obj = obj + zx(:, k)'*Qzx*zx(:, k);
    end
    if soft_u
        obj = obj + zu(:, k)'*Qzu*zu(:, k);
    end
    if soft_d
        obj = obj + zd(:, k)'*Qzd*zd(:,k);
    end
end

con = con + [ xmin(1) <= dref <= xmax(1) ];

ctrl = optimizer(con, obj, sdpsettings, [x(:, 1); dref], u(:, 1));
