
%animation 
F=figure;
col={[1 0 0],[1 1 0],[0 1 0],[0 0 1],[0 1 1],[1 0 1],[0 0 0],[1 1 1]}; %colours
%r_car=4;                                    %car radius
dist_init=x0(1);                            %initial distance between cars                                                                                
v=cell(ncars);                              %cell array for speeds
alfa=cell(ncars);                           %cell array for angles (cars move around a circle)
TextBox_speed=cell(ncars+1);
TextBox_distance=cell(ncars+1);

for i=1:ncars           %ncars=number of cars
        
    v{i}=cumsum(X{i}(:,2));         %vectors of cumulated speed for each car
    c=v{1}(end);                    %circumference (cars trajectory)
    r=c/(2*pi);                     %radius 
    r_car=r/20;
    alfa{i}=((v{i}-(i-1)*(2*r_car+dist_init))*2*pi)/c;  %angle for calculating coordinates x,y
   
    %creating textboxes for speed and distance
    TextBox_speed{i} = uicontrol('style','text');
    set(TextBox_speed{i}, 'Position',  get(TextBox_speed{i},...
        'Position')+[8, 315-(i-1)*25, 0, 0], 'BackgroundColor',col{i});
    TextBox_distance{i} = uicontrol('style','text');
    set(TextBox_distance{i}, 'Position',  get(TextBox_distance{i},...
        'Position')+[8, 315-((ncars+i)*25+5), 0, 0],...
        'BackgroundColor',col{i});
         
end


TextBox_speed{ncars+1} = uicontrol('style','text');
set(TextBox_speed{ncars+1}, 'Position',  get(TextBox_speed{ncars+1},...
    'Position')+[0, 340, 22, 0],'BackgroundColor','c');
set(TextBox_speed{ncars+1},'string','Speed:','FontSize',15);
TextBox_distance{ncars+1} = uicontrol('style','text');
set(TextBox_distance{ncars+1}, 'Position',...
    get(TextBox_distance{ncars+1}, 'Position')+...
    [0, 315-(ncars*25+5), 22, 0],'BackgroundColor','c');
set(TextBox_distance{ncars+1},'string','Distance:','FontSize',15);


%plotting a circle(road)
circle=0:0.01:2*pi;
circleX=r+r*cos(circle);
circleY=0+r*sin(circle);
plot(circleX, circleY,'k','LineWidth',10)
hold on
plot(circleX, circleY,'w--','LineWidth',1)

%axis definition
axis([-20 2*r+10 -(r+15) r+15]);
axis square;
axis off;


%creating cars
car_init=0:0.01:2*pi;
car_initX=r+r_car*cos(car_init);
car_initY=0+r_car*sin(car_init);

h=cell(ncars);

for i=1:ncars
    
    h{i}=patch(car_initX,car_initY,col{i});
    
end


carX=cell(ncars);
carY=cell(ncars);
for xsur=1:length(X{1})
  
    for i=1:ncars
        set(TextBox_speed{i},'string',num2str(X{i}(xsur,2)),'FontSize',12);     %displaying current speed
        set(TextBox_distance{i},'string',num2str(X{i}(xsur,1)),'FontSize',12);  %displaying current distance
     
        if xsur==length(X{1})
            set(TextBox_speed{i},'string','0')      %setting speed to 0 when end of animation
        end
     
        carX{i}=car_initX+r*cos(alfa{i}(xsur));     %calculating x coordinate     
        carY{i}=car_initY+r*sin(alfa{i}(xsur));     %calculating y coordinate
        set(h{i},'XData',carX{i});          %setting x coordinates 
        set(h{i},'YData',carY{i});          %setting y coordinates 
    end
   
    pause(0.15);    %slow animation so that we can watch it
 
end
 







